/**
 * Copyright (C) 2008 - Abiquo Holdings S.L. All rights reserved.
 *
 * Please see /opt/abiquo/tomcat/webapps/legal/ on Abiquo server
 * or contact contact@abiquo.com for licensing information.
 */
package com.abiquo.server.core.accounting;

import java.math.BigInteger;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

import org.hibernate.validator.constraints.Range;

import com.abiquo.server.core.common.BigIntegerDefaultEntityBase;
import com.softwarementors.validation.constraints.Required;

/**
 * Auto-generated with ruby bean_generator.rb
 * com.abiquo.server.core.accounting.AccountingEventDetail accounting_event_detail
 * idAccountingEvent:id startTime:Date endTime:Date idAccountingResourceType:enum resourceType:int
 * resourceUnits:BigInteger resourceName:int idEnterprise:int idVirtualDataCenter:int
 * idVirtualApp:int idVirtualMachine:int costCode:int idStorageTier:int *
 * 
 * @author destevezg
 */
@Entity
@Table(name = AccountingEventDetail.TABLE_NAME)
@org.hibernate.annotations.Table(appliesTo = AccountingEventDetail.TABLE_NAME)
public class AccountingEventDetail extends BigIntegerDefaultEntityBase
{
    public static final String TABLE_NAME = "accounting_event_detail";

    // DO NOT ACCESS: present due to needs of infrastructure support. *NEVER* call from business
    // code
    protected AccountingEventDetail()
    {
        // Just for JPA support
    }

    private final static String ID_COLUMN = "idAccountingEvent";

    @Id
    @GeneratedValue
    @Column(name = ID_COLUMN, nullable = false, columnDefinition = "bigint(20)")
    private BigInteger id;

    public BigInteger getId()
    {
        return this.id;
    }

    public final static String ID_ENTERPRISE_PROPERTY = "idEnterprise";

    private final static boolean ID_ENTERPRISE_REQUIRED = false;

    private final static String ID_ENTERPRISE_COLUMN = "idEnterprise";

    private final static int ID_ENTERPRISE_MIN = Integer.MIN_VALUE;

    private final static int ID_ENTERPRISE_MAX = Integer.MAX_VALUE;

    @Column(name = ID_ENTERPRISE_COLUMN, nullable = !ID_ENTERPRISE_REQUIRED)
    @Range(min = ID_ENTERPRISE_MIN, max = ID_ENTERPRISE_MAX)
    private int idEnterprise;

    public int getIdEnterprise()
    {
        return this.idEnterprise;
    }

    private void setIdEnterprise(int idEnterprise)
    {
        this.idEnterprise = idEnterprise;
    }

    public final static String RESOURCE_TYPE_PROPERTY = "resourceType";

    private final static boolean RESOURCE_TYPE_REQUIRED = false;

    private final static String RESOURCE_TYPE_COLUMN = "resourceType";

    private final static int RESOURCE_TYPE_MIN = Integer.MIN_VALUE;

    private final static int RESOURCE_TYPE_MAX = Integer.MAX_VALUE;

    @Column(name = RESOURCE_TYPE_COLUMN, nullable = !RESOURCE_TYPE_REQUIRED)
    @Range(min = RESOURCE_TYPE_MIN, max = RESOURCE_TYPE_MAX)
    private int resourceType;

    public int getResourceType()
    {
        return this.resourceType;
    }

    private void setResourceType(int resourceType)
    {
        this.resourceType = resourceType;
    }

    public final static String START_TIME_PROPERTY = "startTime";

    private final static boolean START_TIME_REQUIRED = true;

    private final static String START_TIME_COLUMN = "startTime";

    @Column(name = START_TIME_COLUMN, nullable = !START_TIME_REQUIRED) // adding columnDefinition = "timestamp" breaks compatibility with java.util.Date
    private Date startTime;

    public Date getStartTime()
    {
        return this.startTime;
    }

    private void setStartTime(Date startTime)
    {
        this.startTime = startTime;
    }

    public final static String ID_ACCOUNTING_RESOURCE_TYPE_PROPERTY = "idAccountingResourceType";

    private final static boolean ID_ACCOUNTING_RESOURCE_TYPE_REQUIRED = true;

    private final static String ID_ACCOUNTING_RESOURCE_TYPE_COLUMN = "idAccountingResourceType";

    @Enumerated(value = javax.persistence.EnumType.STRING)
    @Column(name = ID_ACCOUNTING_RESOURCE_TYPE_COLUMN, nullable = !ID_ACCOUNTING_RESOURCE_TYPE_REQUIRED, columnDefinition = "tinyint(4)")
    private Integer idAccountingResourceType;

    @Required(value = ID_ACCOUNTING_RESOURCE_TYPE_REQUIRED)
    public Integer getIdAccountingResourceType()
    {
        return this.idAccountingResourceType;
    }

    private void setIdAccountingResourceType(Integer idAccountingResourceType)
    {
        this.idAccountingResourceType = idAccountingResourceType;
    }

    public final static String END_TIME_PROPERTY = "endTime";

    private final static String END_TIME_COLUMN = "endTime";

    private final static boolean END_TIME_REQUIRED = true;

    @Column(name = END_TIME_COLUMN, nullable = !END_TIME_REQUIRED/*, columnDefinition = "TIMESTAMP DEFAULT '0000-00-00 00:00:00'"*/)
    private Date endTime;

    public Date getEndTime()
    {
        return this.endTime;
    }

    private void setEndTime(Date endTime)
    {
        this.endTime = endTime;
    }

    public final static String ID_VIRTUAL_MACHINE_PROPERTY = "idVirtualMachine";

    private final static boolean ID_VIRTUAL_MACHINE_REQUIRED = false;

    private final static String ID_VIRTUAL_MACHINE_COLUMN = "idVirtualMachine";

    private final static int ID_VIRTUAL_MACHINE_MIN = Integer.MIN_VALUE;

    private final static int ID_VIRTUAL_MACHINE_MAX = Integer.MAX_VALUE;

    @Column(name = ID_VIRTUAL_MACHINE_COLUMN, nullable = !ID_VIRTUAL_MACHINE_REQUIRED)
    @Range(min = ID_VIRTUAL_MACHINE_MIN, max = ID_VIRTUAL_MACHINE_MAX)
    private int idVirtualMachine;

    public int getIdVirtualMachine()
    {
        return this.idVirtualMachine;
    }

    private void setIdVirtualMachine(int idVirtualMachine)
    {
        this.idVirtualMachine = idVirtualMachine;
    }

    public final static String RESOURCE_UNITS_PROPERTY = "resourceUnits";

    private final static String RESOURCE_UNITS_COLUMN = "resourceUnits";

    @Column(name = RESOURCE_UNITS_COLUMN, nullable = true, columnDefinition = "bigint(20)")
    private BigInteger resourceUnits;

    public BigInteger getResourceUnits()
    {
        return this.resourceUnits;
    }

    private void setResourceUnits(BigInteger resourceUnits)
    {
        this.resourceUnits = resourceUnits;
    }

    public final static String ID_VIRTUAL_DATA_CENTER_PROPERTY = "idVirtualDataCenter";

    private final static boolean ID_VIRTUAL_DATA_CENTER_REQUIRED = false;

    private final static String ID_VIRTUAL_DATA_CENTER_COLUMN = "idVirtualDataCenter";

    private final static int ID_VIRTUAL_DATA_CENTER_MIN = Integer.MIN_VALUE;

    private final static int ID_VIRTUAL_DATA_CENTER_MAX = Integer.MAX_VALUE;

    @Column(name = ID_VIRTUAL_DATA_CENTER_COLUMN, nullable = !ID_VIRTUAL_DATA_CENTER_REQUIRED)
    @Range(min = ID_VIRTUAL_DATA_CENTER_MIN, max = ID_VIRTUAL_DATA_CENTER_MAX)
    private int idVirtualDataCenter;

    public int getIdVirtualDataCenter()
    {
        return this.idVirtualDataCenter;
    }

    private void setIdVirtualDataCenter(int idVirtualDataCenter)
    {
        this.idVirtualDataCenter = idVirtualDataCenter;
    }

    public final static String RESOURCE_NAME_PROPERTY = "resourceName";

    private final static boolean RESOURCE_NAME_REQUIRED = false;

    private final static String RESOURCE_NAME_COLUMN = "resourceName";

    private final static int RESOURCE_NAME_MIN = Integer.MIN_VALUE;

    private final static int RESOURCE_NAME_MAX = Integer.MAX_VALUE;

    @Column(name = RESOURCE_NAME_COLUMN, nullable = !RESOURCE_NAME_REQUIRED)
    @Range(min = RESOURCE_NAME_MIN, max = RESOURCE_NAME_MAX)
    private int resourceName;

    public int getResourceName()
    {
        return this.resourceName;
    }

    private void setResourceName(int resourceName)
    {
        this.resourceName = resourceName;
    }

    public final static String ID_STORAGE_TIER_PROPERTY = "idStorageTier";

    private final static boolean ID_STORAGE_TIER_REQUIRED = false;

    private final static String ID_STORAGE_TIER_COLUMN = "idStorageTier";

    private final static int ID_STORAGE_TIER_MIN = Integer.MIN_VALUE;

    private final static int ID_STORAGE_TIER_MAX = Integer.MAX_VALUE;

    @Column(name = ID_STORAGE_TIER_COLUMN, nullable = !ID_STORAGE_TIER_REQUIRED)
    @Range(min = ID_STORAGE_TIER_MIN, max = ID_STORAGE_TIER_MAX)
    private int idStorageTier;

    public int getIdStorageTier()
    {
        return this.idStorageTier;
    }

    private void setIdStorageTier(int idStorageTier)
    {
        this.idStorageTier = idStorageTier;
    }

    public final static String COST_CODE_PROPERTY = "costCode";

    private final static boolean COST_CODE_REQUIRED = false;

    private final static String COST_CODE_COLUMN = "costCode";

    private final static int COST_CODE_MIN = Integer.MIN_VALUE;

    private final static int COST_CODE_MAX = Integer.MAX_VALUE;

    @Column(name = COST_CODE_COLUMN, nullable = !COST_CODE_REQUIRED)
    @Range(min = COST_CODE_MIN, max = COST_CODE_MAX)
    private int costCode;

    public int getCostCode()
    {
        return this.costCode;
    }

    private void setCostCode(int costCode)
    {
        this.costCode = costCode;
    }

    public final static String ID_VIRTUAL_APP_PROPERTY = "idVirtualApp";

    private final static boolean ID_VIRTUAL_APP_REQUIRED = false;

    private final static String ID_VIRTUAL_APP_COLUMN = "idVirtualApp";

    private final static int ID_VIRTUAL_APP_MIN = Integer.MIN_VALUE;

    private final static int ID_VIRTUAL_APP_MAX = Integer.MAX_VALUE;

    @Column(name = ID_VIRTUAL_APP_COLUMN, nullable = !ID_VIRTUAL_APP_REQUIRED)
    @Range(min = ID_VIRTUAL_APP_MIN, max = ID_VIRTUAL_APP_MAX)
    private int idVirtualApp;

    public int getIdVirtualApp()
    {
        return this.idVirtualApp;
    }

    private void setIdVirtualApp(int idVirtualApp)
    {
        this.idVirtualApp = idVirtualApp;
    }

    // ************************** Mandatory constructors ***********************
    /* package */AccountingEventDetail(final Date startTime, final Date endTime,
        final Integer idEnterprise, final Integer idVirtualDatacenter)
    {
        setStartTime(startTime);
        setEndTime(endTime);
        setIdAccountingResourceType(0);
        setResourceUnits(BigInteger.ZERO);
        setIdEnterprise(idEnterprise);
        setIdVirtualDataCenter(idVirtualDataCenter);
    }

}
