/**
 * Copyright (C) 2008 - Abiquo Holdings S.L. All rights reserved.
 *
 * Please see /opt/abiquo/tomcat/webapps/legal/ on Abiquo server
 * or contact contact@abiquo.com for licensing information.
 */
package com.abiquo.server.core.config;

import javax.persistence.EntityManager;

import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Restrictions;
import org.springframework.stereotype.Repository;

import com.abiquo.server.core.common.persistence.DefaultDAOBase;

@Repository("jpaLicenseDAO")
public class LicenseDAO extends DefaultDAOBase<Integer, License>
{
    public LicenseDAO()
    {
        super(License.class);
    }

    public LicenseDAO(EntityManager entityManager)
    {
        super(License.class, entityManager);
    }

    public boolean existsAnyWithData(String data)
    {
        return existsAnyByCriterions(equalsData(data));
    }

    public boolean existsAnyOtherWithData(License license, String data)
    {
        return this.existsAnyOtherByCriterions(license, equalsData(data));
    }

    private Criterion equalsData(String data)
    {
        return Restrictions.eq(License.DATA_PROPERTY, data);
    }
}
