/**
 * Copyright (C) 2008 - Abiquo Holdings S.L. All rights reserved.
 *
 * Please see /opt/abiquo/tomcat/webapps/legal/ on Abiquo server
 * or contact contact@abiquo.com for licensing information.
 */
package com.abiquo.server.core.config;

import java.util.Collection;

import javax.persistence.EntityManager;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.abiquo.server.core.common.DefaultRepBase;

@Repository
public class SystemPropertyRep extends DefaultRepBase
{
    @Autowired
    private SystemPropertyDAO dao;

    public SystemPropertyRep()
    {
    }

    public SystemPropertyRep(final EntityManager em)
    {
        this.dao = new SystemPropertyDAO(em);
    }

    public SystemProperty findById(final Integer id)
    {
        return this.dao.findById(id);
    }

    public SystemProperty findByName(final String name)
    {
        return this.dao.findByName(name);
    }

    public Collection<SystemProperty> findByComponent(final String component)
    {
        return this.dao.findByComponent(component);
    }

    public Collection<SystemProperty> findAll()
    {
        return this.dao.findAll();
    }

    public void insert(final SystemProperty systemProperty)
    {
        this.dao.persist(systemProperty);
        this.dao.flush();
    }

    public void delete(final SystemProperty systemProperty)
    {
        this.dao.remove(systemProperty);
        this.dao.flush();
    }

    public void update(final SystemProperty systemProperty)
    {
        this.dao.flush();
    }

    public boolean existsAnyWithName(final String name)
    {
        return dao.existsAnyWithName(name);
    }

    public boolean existsAnyOtherWithName(final SystemProperty systemProperty, final String name)
    {
        return dao.existsAnyOtherWithName(systemProperty, name);
    }
}
