/**
 * Copyright (C) 2008 - Abiquo Holdings S.L. All rights reserved.
 *
 * Please see /opt/abiquo/tomcat/webapps/legal/ on Abiquo server
 * or contact contact@abiquo.com for licensing information.
 */
package com.abiquo.server.core.enterprise;

import java.util.Collection;
import java.util.HashMap;
import java.util.List;

import javax.persistence.EntityManager;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.abiquo.server.core.common.DefaultRepBase;
import com.abiquo.server.core.event.Event;
import com.abiquo.server.core.event.EventDAO;
import com.abiquo.server.core.util.FilterOptions;

/**
 * @author vmahe
 */
@Repository
public class EventRep extends DefaultRepBase
{
    @Autowired
    private EventDAO eventDAO;

    public EventRep()
    {

    }

    public EventRep(final EntityManager entityManager)
    {
        assert entityManager != null;
        assert entityManager.isOpen();

        this.eventDAO = new EventDAO(entityManager);
    }

    public List<Event> getEvents(final User currentUser, final FilterOptions filterOptions,
        final HashMap<String, String> filters, final Collection<User> listOfUsers,
        final Integer idEnterprise, final Integer idUser,
        final Collection<Integer> listOfEnterprises)
    {
        return eventDAO.getEvents(currentUser, filterOptions, filters, listOfUsers, idEnterprise,
            idUser, listOfEnterprises);
    }

    public Event getEvent(final Integer eventId)
    {
        return eventDAO.findById(eventId);
    }

    public Event insertEvent(final Event event)
    {
        eventDAO.persist(event);
        eventDAO.flush();

        return event;
    }
}
