/**
 * Copyright (C) 2008 - Abiquo Holdings S.L. All rights reserved.
 *
 * Please see /opt/abiquo/tomcat/webapps/legal/ on Abiquo server
 * or contact contact@abiquo.com for licensing information.
 */
package com.abiquo.server.core.infrastructure.storage;

import java.util.List;

import javax.persistence.EntityManager;

import org.hibernate.Criteria;
import org.hibernate.criterion.Restrictions;
import org.springframework.stereotype.Repository;

import com.abiquo.server.core.common.persistence.DefaultDAOBase;

@Repository("jpaCabinetDAO")
/* package */class StorageDeviceDAO extends DefaultDAOBase<Integer, StorageDevice>
{

    public StorageDeviceDAO()
    {
        super(StorageDevice.class);
    }

    public StorageDeviceDAO(final EntityManager entityManager)
    {
        super(StorageDevice.class, entityManager);
    }

    @SuppressWarnings("unchecked")
    public List<StorageDevice> getDevicesByDatacenter(final Integer datacenterId)
    {

        Criteria criteria = createCriteria(Restrictions.eq("datacenter.id", datacenterId));
        return criteria.list();

    }

    public StorageDevice getDeviceById(final Integer datacenterId, final Integer deviceId)
    {
        Criteria criteria =
            createCriteria(Restrictions.eq("id", deviceId),
                Restrictions.eq("datacenter.id", datacenterId));
        Object obj = criteria.uniqueResult();
        return (StorageDevice) obj;
    }

    public StorageDevice findDeviceByManagementIP(final Integer datacenterId,
        final String managementIp)
    {
        Criteria criteria =
            createCriteria(Restrictions.eq("managementIp", managementIp),
                Restrictions.eq("datacenter.id", datacenterId));
        Object obj = criteria.uniqueResult();
        return (StorageDevice) obj;
    }

}
