/**
 * Copyright (C) 2008 - Abiquo Holdings S.L. All rights reserved.
 *
 * Please see /opt/abiquo/tomcat/webapps/legal/ on Abiquo server
 * or contact contact@abiquo.com for licensing information.
 */
package com.abiquo.server.core.infrastructure.storage;

import java.util.List;

import javax.persistence.EntityManager;

import org.hibernate.Criteria;
import org.hibernate.criterion.Restrictions;
import org.springframework.stereotype.Repository;

import com.abiquo.server.core.common.persistence.DefaultDAOBase;

@Repository("jpaTierDAO")
/* package */class TierDAO extends DefaultDAOBase<Integer, Tier>
{
    public TierDAO()
    {
        super(Tier.class);
    }

    public TierDAO(final EntityManager entityManager)
    {
        super(Tier.class, entityManager);
    }

    @SuppressWarnings("unchecked")
    public List<Tier> getTiersByDatacenter(final Integer datacenterId)
    {
        Criteria criteria = createCriteria(Restrictions.eq("datacenter.id", datacenterId));
        return criteria.list();
    }

    @SuppressWarnings("unchecked")
    public List<Tier> getEnableTiersByDatacenter(final Integer datacenterId)
    {
        Criteria criteria =
            createCriteria(Restrictions.eq("datacenter.id", datacenterId),
                Restrictions.eq(Tier.ENABLED_PROPERTY, true));

        return criteria.list();
    }

    public Tier getTierById(final Integer datacenterId, final Integer tierId)
    {

        Criteria criteria =
            createCriteria(Restrictions.eq("datacenter.id", datacenterId)).add(
                Restrictions.eq("id", tierId));
        Object obj = criteria.uniqueResult();
        return (Tier) obj;
    }

}
