/**
 * Copyright (C) 2008 - Abiquo Holdings S.L. All rights reserved.
 *
 * Please see /opt/abiquo/tomcat/webapps/legal/ on Abiquo server
 * or contact contact@abiquo.com for licensing information.
 */
package com.abiquo.server.core.task;

import java.util.ArrayList;
import java.util.List;

import com.abiquo.model.redis.RedisEntityBase;

/**
 * A simple cache entry, with id and a list of strings.
 * 
 * @author eruiz
 */
public class CacheEntry extends RedisEntityBase
{
    protected String id;

    protected List<String> values;

    public CacheEntry(final String id)
    {
        this.id = id;
        this.values = new ArrayList<String>();
    }

    @Override
    protected String getIdAsString()
    {
        return getId();
    }

    public String getId()
    {
        return id;
    }

    public void setId(String id)
    {
        this.id = id;
    }

    public List<String> getValues()
    {
        return values;
    }
}
