/**
 * Copyright (C) 2008 - Abiquo Holdings S.L. All rights reserved.
 *
 * Please see /opt/abiquo/tomcat/webapps/legal/ on Abiquo server
 * or contact contact@abiquo.com for licensing information.
 */
/**
 * 
 */
package com.abiquo.server.core.util;

import java.util.ArrayList;
import java.util.List;

/**
 * Class to encapsulate a common arrayList and set its max result for paging purposes.
 * 
 * @author jdevesa@abiquo.com
 */
public class PagedList<T> extends ArrayList<T>
{
    /**
     * Generated serial version
     */
    private static final long serialVersionUID = 1723031368985519696L;

    /**
     * Total results of the query.
     */
    private Integer totalResults;

    /**
     * Size of the page
     */
    private Integer pageSize;

    /**
     * Current page
     */
    private Integer currentElement;

    public PagedList()
    {
        super();
    }

    public PagedList(final List<T> resultList)
    {
        super(resultList);
    }

    /**
     * @param totalResults the totalResults to set
     */
    public void setTotalResults(final Integer totalResults)
    {
        this.totalResults = totalResults;
    }

    /**
     * @return the totalResults
     */
    public Integer getTotalResults()
    {
        return totalResults;
    }

    /**
     * @param pageSize the pageSize to set
     */
    public void setPageSize(final Integer pageSize)
    {
        this.pageSize = pageSize;
    }

    /**
     * @return the pageSize
     */
    public Integer getPageSize()
    {
        return pageSize;
    }

    /**
     * @param currentPage the currentPage to set
     */
    public void setCurrentElement(final Integer currentElement)
    {
        this.currentElement = currentElement;
    }

    /**
     * @return the currentPage
     */
    public Integer getCurrentElement()
    {
        return currentElement;
    }
}
